----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:25:52 11/13/2007 
-- Design Name: 
-- Module Name:    spo_prot - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
-- 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-- v0.0 - working in game
--      
-- Freeware public code, not for resale or commercial use
-- 
-- Great job by the Mame guys for figuring out all the ports and function :) 
-- makes the implementation a lot easier...
--
-- Changes from base mame theory-of-operation:
--
-- 	reads from D012/D7C1 always read memory ( doesn't seem to effect anything )
-- 	writes to D012/D7C1 pass thru' into the CPLD 
-- 	the registers are all only 4 bits in size 
-- 	z80 reset clears the state of register 13
-- 	
-- Other Notes:
-- 	rely on the compilers optimizer to remove unused bits in the 'prot_mem' array
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity spo_prot is
    Port ( ad : in  STD_LOGIC_VECTOR (15 downto 0);
           db : inout  STD_LOGIC_VECTOR (3 downto 0);
           dbhi: inout  STD_LOGIC_VECTOR (3 downto 0);
           mreq : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           iorq : in  STD_LOGIC;
           rd : in  STD_LOGIC;
           wr : in  STD_LOGIC;
           rd_out : out  STD_LOGIC);
end spo_prot;


architecture Behavioral of spo_prot is


type   intern_reg is  array( 0 to 15 ) of   std_logic_vector( 3 downto 0 );
signal prot_mem :intern_reg ; 


begin


process( db, iorq, mreq, reset, ad, wr )
begin

if ( reset='0' ) then
  
	prot_mem( 13 ) <= "0000";
	
else

	
-- I/O write
 if ( rising_edge( wr ) and  ( iorq ='0' or mreq ='0') ) then

  if ( mreq='0' ) then
  
  if (  ad = X"d012"  and	prot_mem( 13 )=x"0a"  ) then
		prot_mem(7) <= db;
	 end if;
	 
	if ( ad = X"d7c1" and ( prot_mem( 13 )=x"0b" or prot_mem( 13 )=x"03" )) then
		prot_mem(8) <= db;	 	 
	end if;
  
  else
  
  -- iorq was '0'
  if ( ad(3 downto 0 ) = "0111" ) then
 
   case  ad(7 downto 4 )  is
              when X"0" =>
				  
				  		if ( prot_mem( 13 ) =  x"0a" ) then
							prot_mem(7) <= db;  -- data for memory read d012
						else						
							if ( prot_mem( 13 ) =X"0b" or  prot_mem( 13) = X"03" ) then
								prot_mem( 8 ) <= db;  -- data for memory read d7c1
							else
								prot_mem( 0 ) <= db;  
							end if;
						end if;
						
			  
--              when X"1" =>

              when X"2" =>
				  		if ( prot_mem( 13 ) =  x"09" ) then
							prot_mem(2) <= db;
						end if;
				  
              when X"3" =>
				  		if ( prot_mem( 13 ) =  x"09" ) then
							prot_mem(3)( 2 downto 0 ) <= db( 2 downto 0);
						end if;
						
--              when X"4" =>
              when X"5" =>
				  		if ( prot_mem( 13 ) =  x"09" ) then
							prot_mem(5)(1 downto 0) <= db( 1 downto 0 ) ;
						end if;

              when X"6" =>
				  		if ( prot_mem( 13 ) =  x"09" ) then
							prot_mem(6)(2 downto 0) <= db(2 downto 0);
						end if;
--              when X"7" =>
--              when X"8" =>
--              when X"9" =>

              when X"A" =>
						prot_mem( 10 )( 0 )  <= db(0);
				  
              when X"B" =>
						prot_mem( 11 )( 1 downto 0 )  <= db( 1 downto 0);

              when X"D" =>
						prot_mem( 13 ) <= db;

--              when X"E" =>
						
              when X"F" =>
						prot_mem( 15 ) <= db;
						
					when others =>
						null;

	end case;
  end if; -- write to the prot chip
 
 end if; --mem or IO check
  
 end if; -- z80 write

end if; -- check for reset

end process;


process( db, iorq, mreq, reset, ad, wr, rd )
begin
	
 if
    ( rd = '0' and iorq ='0' and ad(3 downto 0 ) = "0111" )  
	  
 then

	-- reading from the protection chip keep the rest of the system OFF the z80 bus
	rd_out <= '1';

	-- i/o read
	--if ( iorq = '0' ) then

		case  ad(7 downto 4 )  is

				when X"0" =>
					dbhi 	<= "0000";

						if ( prot_mem( 13 ) =  x"0a" ) then
							db <= prot_mem( 7 );
						else					
							if ( prot_mem( 13 ) =  x"0b" or prot_mem( 13 ) =  x"03" ) then
								db <= prot_mem( 8 );
							else
								db <= prot_mem( 0 );
							end if;
						end if;

				when X"1" =>
					dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"08" ) then
								db <= prot_mem( 0 );
						else
								db <= "0000";
						end if;
						
				when X"2" =>
					dbhi 	<= "0000";

						if ( prot_mem( 13 ) =  x"0b" ) then
								db <= X"9";
						else
							if ( prot_mem( 13 ) =  x"09" ) then
									db <= prot_mem(2);
							else
								db <= "0000";
							end if;
						end if;
						
				when X"3" =>
					dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"09" ) then
								db(3) <= '0';
								db(2 downto 0 ) <= prot_mem( 3 )( 2 downto 0 );
						else
								db <= "0000";
						end if;

				when X"5" =>
					dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"09" ) then
								db(3 downto 2 ) <= "00";
								db(1 downto 0 ) <= prot_mem( 5 )( 1 downto 0 );
						else
								db <= "0000";
						end if;

				when X"6" =>
					dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"0b" ) then
								db <= X"a";
						else
							if ( prot_mem( 13 ) =  x"09" ) then
								db(3) <= '0';
								db(2 downto 0 ) <= prot_mem( 6 )( 2 downto 0 );
							else
								db <= "0000";
							end if;
						end if;

				when X"9" =>
						if ( prot_mem( 13 ) =  x"09" ) then
								dbhi <= prot_mem( 15 );
								db <= "0000";
						else
								db 	<= "0000";
								dbhi 	<= "0000";
						end if;


				when X"a" =>
						dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"0b" ) then
								db <= X"5";
						else
							if ( prot_mem( 13 ) =  x"09" ) then
								db(3 downto 1 ) <= "000";
								db(         0 ) <= prot_mem( 10 )( 0 );
							else
								db <= "0000";
							end if;
						end if;

				when X"b" =>
						dbhi 	<= "0000";
						if ( prot_mem( 13 ) =  x"0b" ) then
								db <= X"5";
						else

							if ( prot_mem( 13 ) =  x"09" ) then
								db( 3 downto 2 ) 	<= "00";
								db( 1 downto 0 ) 	<= prot_mem( 11 )( 1 downto 0 );
							else
								db <= "0000";
							end if;
						end if;


				when X"c" =>
								db <= X"0";
								dbhi 	<= "0000";

				when X"d" =>
								db <= prot_mem( 13 );
								dbhi 	<= "0000";
				  
				when others =>
								db <= "0000";
								dbhi 	<= "0000";
		end case;
    
	
 else 
   db 	<= "ZZZZ";
   dbhi 	<= "ZZZZ";
	rd_out <= rd;
 end if;
 
end process;

end Behavioral;

